#include "../../../lib/std.mi"

Global Group groupScript;
Global Text textLabel;
Global Button buttonCheckbox;

System.onScriptLoaded() {
	groupScript = System.getScriptGroup();
	textLabel = groupScript.findobject("checkbox.label");
	buttonCheckbox = groupScript.findobject("checkbox.toggle");
}

System.onSetXuiParam(String strParam, String strValue) {
	if (System.strLower(strParam) == "label") textLabel.setText(strValue);
}

buttonCheckbox.onActivate(Boolean boolActive) {
	String strCurrentHoverImage = buttonCheckbox.getXMLParam("hoverimage");
	if (boolActive) {
		if (System.strSearch(strCurrentHoverImage, "radio") > -1) {
			buttonCheckbox.setXMLParam("hoverimage", "config.button.option.radio.activehover");
		} else {
			buttonCheckbox.setXMLParam("hoverimage", "config.button.option.checkbox.activehover");
		}
	} else {
		if (System.strSearch(strCurrentHoverImage, "radio") > -1) {
			buttonCheckbox.setXMLParam("hoverimage", "config.button.option.radio.hover");
		} else {
			buttonCheckbox.setXMLParam("hoverimage", "config.button.option.checkbox.hover");
		}
	}
}
