Function initEqualizer();
Function unloadEqualizer();
Function setEqualizerRegion(Int intEqualizerBandValue, Layer layerEqualizerBand);
Function setCrossfadeDurationRegion(Int intCrossfadeDurationValue);

Global Layer layerConfigNormalEqualizerBand00;
Global Layer layerConfigNormalEqualizerBand01;
Global Layer layerConfigNormalEqualizerBand02;
Global Layer layerConfigNormalEqualizerBand03;
Global Layer layerConfigNormalEqualizerBand04;
Global Layer layerConfigNormalEqualizerBand05;
Global Layer layerConfigNormalEqualizerBand06;
Global Layer layerConfigNormalEqualizerBand07;
Global Layer layerConfigNormalEqualizerBand08;
Global Layer layerConfigNormalEqualizerBand09;
Global Layer layerConfigNormalEqualizerBand10;

Global Slider sliderConfigNormalEqualizerBand00;
Global Slider sliderConfigNormalEqualizerBand01;
Global Slider sliderConfigNormalEqualizerBand02;
Global Slider sliderConfigNormalEqualizerBand03;
Global Slider sliderConfigNormalEqualizerBand04;
Global Slider sliderConfigNormalEqualizerBand05;
Global Slider sliderConfigNormalEqualizerBand06;
Global Slider sliderConfigNormalEqualizerBand07;
Global Slider sliderConfigNormalEqualizerBand08;
Global Slider sliderConfigNormalEqualizerBand09;
Global Slider sliderConfigNormalEqualizerBand10;

Global Map mapEqualizer;
Global Region regionEqualizer;

Global Layer layerConfigNormalCrossfadeDuration;
Global Slider sliderConfigNormalCrossfadeDuration;
Global Text textConfigNormalCrossfadeDuration;

Global Map mapCrossfadeDuration;
Global Region regionCrossfadeDuration;

Global Button buttonConfigNormalEqualizerSetMax;
Global Button buttonConfigNormalEqualizerSetNormal;
Global Button buttonConfigNormalEqualizerSetMin;

initEqualizer() {
	layerConfigNormalEqualizerBand00 = layoutConfigNormal.findObject("config.display.background.equalizer.band.00");
	layerConfigNormalEqualizerBand01 = layoutConfigNormal.findObject("config.display.background.equalizer.band.01");
	layerConfigNormalEqualizerBand02 = layoutConfigNormal.findObject("config.display.background.equalizer.band.02");
	layerConfigNormalEqualizerBand03 = layoutConfigNormal.findObject("config.display.background.equalizer.band.03");
	layerConfigNormalEqualizerBand04 = layoutConfigNormal.findObject("config.display.background.equalizer.band.04");
	layerConfigNormalEqualizerBand05 = layoutConfigNormal.findObject("config.display.background.equalizer.band.05");
	layerConfigNormalEqualizerBand06 = layoutConfigNormal.findObject("config.display.background.equalizer.band.06");
	layerConfigNormalEqualizerBand07 = layoutConfigNormal.findObject("config.display.background.equalizer.band.07");
	layerConfigNormalEqualizerBand08 = layoutConfigNormal.findObject("config.display.background.equalizer.band.08");
	layerConfigNormalEqualizerBand09 = layoutConfigNormal.findObject("config.display.background.equalizer.band.09");
	layerConfigNormalEqualizerBand10 = layoutConfigNormal.findObject("config.display.background.equalizer.band.10");
	
	sliderConfigNormalEqualizerBand00 = layoutConfigNormal.findObject("config.slider.equalizer.band.00");
	sliderConfigNormalEqualizerBand01 = layoutConfigNormal.findObject("config.slider.equalizer.band.01");
	sliderConfigNormalEqualizerBand02 = layoutConfigNormal.findObject("config.slider.equalizer.band.02");
	sliderConfigNormalEqualizerBand03 = layoutConfigNormal.findObject("config.slider.equalizer.band.03");
	sliderConfigNormalEqualizerBand04 = layoutConfigNormal.findObject("config.slider.equalizer.band.04");
	sliderConfigNormalEqualizerBand05 = layoutConfigNormal.findObject("config.slider.equalizer.band.05");
	sliderConfigNormalEqualizerBand06 = layoutConfigNormal.findObject("config.slider.equalizer.band.06");
	sliderConfigNormalEqualizerBand07 = layoutConfigNormal.findObject("config.slider.equalizer.band.07");
	sliderConfigNormalEqualizerBand08 = layoutConfigNormal.findObject("config.slider.equalizer.band.08");
	sliderConfigNormalEqualizerBand09 = layoutConfigNormal.findObject("config.slider.equalizer.band.09");
	sliderConfigNormalEqualizerBand10 = layoutConfigNormal.findObject("config.slider.equalizer.band.10");
	
	mapEqualizer = new Map;
	mapEqualizer.loadMap("config.map.equalizer");
	regionEqualizer = new Region;
	
	layerConfigNormalCrossfadeDuration = layoutConfigNormal.findObject("config.display.background.crossfade.duration");
	sliderConfigNormalCrossfadeDuration = layoutConfigNormal.findObject("config.slider.crossfade.duration");
	textConfigNormalCrossfadeDuration = layoutConfigNormal.findObject("config.slider.crossfade.duration.display");
	
	mapCrossfadeDuration = new Map;
	mapCrossfadeDuration.loadMap("config.map.crossfade.duration");
	regionCrossfadeDuration = new Region;
	
	buttonConfigNormalEqualizerSetMax = layoutConfigNormal.findObject("config.button.equalizer.setMax");
	buttonConfigNormalEqualizerSetNormal = layoutConfigNormal.findObject("config.button.equalizer.setNormal");
	buttonConfigNormalEqualizerSetMin = layoutConfigNormal.findObject("config.button.equalizer.setMin");
	
	setEqualizerRegion(128 - System.getEqBand(0), layerConfigNormalEqualizerBand00);
	setEqualizerRegion(128 - System.getEqBand(1), layerConfigNormalEqualizerBand01);
	setEqualizerRegion(128 - System.getEqBand(2), layerConfigNormalEqualizerBand02);
	setEqualizerRegion(128 - System.getEqBand(3), layerConfigNormalEqualizerBand03);
	setEqualizerRegion(128 - System.getEqBand(4), layerConfigNormalEqualizerBand04);
	setEqualizerRegion(128 - System.getEqBand(5), layerConfigNormalEqualizerBand05);
	setEqualizerRegion(128 - System.getEqBand(6), layerConfigNormalEqualizerBand06);
	setEqualizerRegion(128 - System.getEqBand(7), layerConfigNormalEqualizerBand07);
	setEqualizerRegion(128 - System.getEqBand(8), layerConfigNormalEqualizerBand08);
	setEqualizerRegion(128 - System.getEqBand(9), layerConfigNormalEqualizerBand09);
	setEqualizerRegion(128 - System.getEqPreamp(), layerConfigNormalEqualizerBand10);

	configAttribute_crossfadeTime.setData(configAttribute_crossfadeTime.getData());
}

unloadEqualizer() {
	delete mapEqualizer;
	delete mapCrossfadeDuration;
	delete regionEqualizer;
	delete regionCrossfadeDuration;
}

setEqualizerRegion(Int intEqualizerBandValue, Layer layerEqualizerBand) {
	regionEqualizer.loadFromMap(mapEqualizer, intEqualizerBandValue, false);
	layerEqualizerBand.setRegion(regionEqualizer);
}

setCrossfadeDurationRegion(Int intCrossfadeDurationValue) {
	regionCrossfadeDuration.loadFromMap(mapCrossfadeDuration, intCrossfadeDurationValue, true);
	layerConfigNormalCrossfadeDuration.setRegion(regionCrossfadeDuration);
}

System.onEqPreampChanged(Int intPreampValue) {
	setEqualizerRegion(((128 - intPreampValue) - 1), layerConfigNormalEqualizerBand10);
}

System.onEqBandChanged(Int intEqualizerBand, Int intEqualizerBandValue) {
	if (intEqualizerBand == 0) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand00);
	} else if (intEqualizerBand == 1) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand01);
	} else if (intEqualizerBand == 2) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand02);
	} else if (intEqualizerBand == 3) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand03);
	} else if (intEqualizerBand == 4) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand04);
	} else if (intEqualizerBand == 5) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand05);
	} else if (intEqualizerBand == 6) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand06);
	} else if (intEqualizerBand == 7) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand07);
	} else if (intEqualizerBand == 8) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand08);
	} else if (intEqualizerBand == 9) {
		setEqualizerRegion(((128 - intEqualizerBandValue) - 1), layerConfigNormalEqualizerBand09);
	}
}

configAttribute_crossfadeTime.onDataChanged() {
	if (boolMyChange) return;
	boolMyChange = true;
	configAttribute_system_crossfadeTime.setData(configAttribute_crossfadeTime.getData());
	if (mapCrossfadeDuration != NULL && regionCrossfadeDuration != NULL) {
		Int intCrossfadeDurationValue = System.stringToInteger(configAttribute_crossfadeTime.getData());
		setCrossfadeDurationRegion((intCrossfadeDurationValue * 255) / 20);
		textConfigNormalCrossfadeDuration.setText(System.integerToString(intCrossfadeDurationValue));
	}
	boolMyChange = false;
}

buttonConfigNormalEqualizerSetMax.onLeftClick() {
	for (Int i = 0; i < 10; i++) System.setEqBand(i, 127);
}

buttonConfigNormalEqualizerSetNormal.onLeftClick() {
	for (Int i = 0; i < 10; i++) System.setEqBand(i, 0);
}

buttonConfigNormalEqualizerSetMin.onLeftClick() {
	for (Int i = 0; i < 10; i++) System.setEqBand(i, -127);
}