Function initSliders();

Global Slider sliderMainShadeSeek;
Global Slider sliderMainShadeSeekGhost;

Global Slider sliderPLShadeSeek;
Global Slider sliderPLShadeSeekGhost;

initSliders() {
	sliderMainShadeSeek = layoutMainShade.findObject("player.slider.seek");
	sliderMainShadeSeekGhost = layoutMainShade.findObject("player.slider.seek.ghost");
	
	sliderPLShadeSeek = layoutPLShade.findObject("pledit.slider.seek");
	sliderPLShadeSeekGhost = layoutPLShade.findObject("pledit.slider.seek.ghost");
	
	sliderMainShadeSeekGhost.setAlpha(0);
	sliderPLShadeSeekGhost.setAlpha(0);
}

sliderMainShadeSeekGhost.onLeftButtonDown(Int intPosX, Int intPosY) { 
	sliderMainShadeSeekGhost.setAlpha(128); 
	boolReleaseSongTicker = false;
}
sliderMainShadeSeekGhost.onLeftButtonUp(Int intPosX, Int intPosY) { 
	sliderMainShadeSeekGhost.setAlpha(1); 
	boolReleaseSongTicker = true;
}
sliderMainShadeSeekGhost.onSetFinalPosition(Int intPostion) { sliderMainShadeSeekGhost.setAlpha(1); }
sliderMainShadeSeekGhost.onSetPosition(Int intPosition) {
	if (sliderMainShadeSeekGhost.getAlpha() == 1) {
		return;
	}
	Float floatPlayItemLength = System.getPlayItemLength();
	if (floatPlayItemLength > 0) {
		Float floatPositionPercentage = intPosition / 255 * 100;
		Int intNewPosition = floatPlayItemLength * floatPositionPercentage / 100;
		showActionInfo("Seek To: " + System.integerToTime(intNewPosition) + " / " + System.integerToTime(floatPlayItemLength));
	}
}

sliderPLShadeSeekGhost.onLeftButtonDown(Int intPosX, Int intPosY) { 
	sliderPLShadeSeekGhost.setAlpha(128); 
	boolReleaseSongTicker = false;
}
sliderPLShadeSeekGhost.onLeftButtonUp(Int intPosX, Int intPosY) { 
	sliderPLShadeSeekGhost.setAlpha(1); 
	boolReleaseSongTicker = true;
}
sliderPLShadeSeekGhost.onSetFinalPosition(Int intPostion) { sliderPLShadeSeekGhost.setAlpha(1); }
sliderPLShadeSeekGhost.onSetPosition(Int intPosition) {
	if (sliderPLShadeSeekGhost.getAlpha() == 1) {
		return;
	}
	Float floatPlayItemLength = System.getPlayItemLength();
	if (floatPlayItemLength > 0) {
		Float floatPositionPercentage = intPosition / 255 * 100;
		Int intNewPosition = floatPlayItemLength * floatPositionPercentage / 100;
		showActionInfo("Seek To: " + System.integerToTime(intNewPosition) + " / " + System.integerToTime(floatPlayItemLength));
	}
}