#include "../../../lib/std.mi"

#define MAIN_ATTRIBS_MGR

#include "attribs.m"
#include "global.m"
#include "utility.m"
#include "autorepeatbutton.m"
#include "config.m"
#include "equalizer.m"
#include "drawers.m"
#include "seek.m"
#include "volume.m"
#include "time.m"
#include "visualizers.m"
#include "sliders.m"
#include "shadesize.m"
#include "songinfo.m"
#include "behaviors.m"

System.onScriptLoaded() {
	initAttribs();
	initGlobal();
	initConfig();
	initEqualizer();
	initDrawers();
	initSeek();
	initVolume();
	initTime();
	initVisualizers();
	initSliders();
	initShadeSize();
	initSongInfo();
	initBehaviors();
}

System.onScriptUnloading() {
	unloadGlobal();
	unloadEqualizer();
	unloadSeek();
	unloadVolume();
	unloadVisualizers();
	unloadBehaviors();
}