Function initTime();
Function setDisplayTime(String strNewText);

Global Text textMainNormalTimeMinutes;
Global Text textMainNormalTimeSeconds;
Global Layer layerMainNormalTimeElapsed;
Global Layer layerMainNormalTimeRemain;
Global Layer layerMainNormalTimeColon;

Global Text textMainCompactTimeMinutes;
Global Text textMainCompactTimeSeconds;
Global Layer layerMainCompactTimeElapsed;
Global Layer layerMainCompactTimeRemain;
Global Layer layerMainCompactTimeColon;

Global Text textMainShadeTimeMinutes;
Global Text textMainShadeTimeSeconds;
Global Layer layerMainShadeTimeRemain;
Global Layer layerMainShadeTimeColon;

Global Text textMainNormalTimeSource;

initTime() {
	textMainNormalTimeMinutes = layoutMainNormal.findObject("player.time.minutes");
	textMainNormalTimeSeconds = layoutMainNormal.findObject("player.time.seconds");
	layerMainNormalTimeElapsed = layoutMainNormal.findObject("player.background.drawer.display.elapsed");
	layerMainNormalTimeRemain = layoutMainNormal.findObject("player.background.drawer.display.remain");
	layerMainNormalTimeColon = layoutMainNormal.findObject("player.background.drawer.display.colon");
	
	textMainCompactTimeMinutes = layoutMainCompact.findObject("player.time.minutes");
	textMainCompactTimeSeconds = layoutMainCompact.findObject("player.time.seconds");
	layerMainCompactTimeElapsed = layoutMainCompact.findObject("player.background.drawer.display.elapsed");
	layerMainCompactTimeRemain = layoutMainCompact.findObject("player.background.drawer.display.remain");
	layerMainCompactTimeColon = layoutMainCompact.findObject("player.background.drawer.display.colon");
	
	textMainShadeTimeMinutes = layoutMainShade.findObject("player.time.minutes");
	textMainShadeTimeSeconds = layoutMainShade.findObject("player.time.seconds");
	layerMainShadeTimeRemain = layoutMainShade.findObject("player.background.display.remain");
	layerMainShadeTimeColon = layoutMainShade.findObject("player.background.display.colon");
	
	textMainNormalTimeSource = layoutMainNormal.findObject("player.time.source");
	setDisplayTime(textMainNormalTimeSource.getText());
}

textMainNormalTimeSource.onTextChanged(String strNewText) {
	setDisplayTime(strNewText);
}

setDisplayTime(String strNewText) {
	String strMinutes;
	String strSeconds;
	
	if (strNewText == "") strNewText = "00:00";
	
	if (System.strSearch(strNewText, "-") > -1) {
		strNewText = System.strMid(strNewText, 1, System.strLen(strNewText) - 1);
		layerMainNormalTimeElapsed.hide();
		layerMainNormalTimeRemain.show();
		layerMainCompactTimeElapsed.hide();
		layerMainCompactTimeRemain.show();
		layerMainShadeTimeRemain.show();
	} else {
		layerMainNormalTimeRemain.hide();
		layerMainNormalTimeElapsed.show();
		layerMainCompactTimeRemain.hide();
		layerMainCompactTimeElapsed.show();
		layerMainShadeTimeRemain.hide();
	}
	
	strMinutes = System.strRight("00" + System.strLeft(strNewText, System.strSearch(strNewText, ":")), 2);
	strSeconds = System.strRight(strNewText, 2);
	
	textMainNormalTimeMinutes.setText(strMinutes);
	textMainNormalTimeSeconds.setText(strSeconds);
	textMainCompactTimeMinutes.setText(strMinutes);
	textMainCompactTimeSeconds.setText(strSeconds);
	textMainShadeTimeMinutes.setText(strMinutes);
	textMainShadeTimeSeconds.setText(strSeconds);
}