#include "../../../lib/std.mi"
#include "attribs.m"

Global Group groupScript;
Global GuiObject objBackgroundDefault;
Global GuiObject objBackgroundAlternate;
Global Text textTooltip;

System.onScriptLoaded() {
	initAttribs();
	
	groupScript = System.getScriptGroup();
	objBackgroundDefault = groupScript.findObject("tooltip.grid");
	objBackgroundAlternate = groupScript.findObject("tooltip2.grid");
	textTooltip = groupScript.findobject("tooltip.text");
	
	textTooltip.bringToFront();
	
	if (configAttribute_alternateTooltips.getData() == "1") {
		objBackgroundAlternate.show();
		textTooltip.setXMLParam("color", "font.color.titlebar");
		textTooltip.setXMLParam("shadowcolor", "font.color.titlebar.shadow");
		textTooltip.setXMLParam("shadowy", "1");
	} else {
		objBackgroundAlternate.hide();
		textTooltip.setXMLParam("color", "wasabi.tooltips.textcolor");
		textTooltip.setXMLParam("shadowcolor", "wasabi.tooltips.textcolor");
		textTooltip.setXMLParam("shadowy", "0");
	}
}