Function initVisualizers();
Function unloadVisualizers();
Function refreshVisualizers();
Function Int getVisualizerAverageOverTime(Int intCurrentAverage);
Function setMainVisualizer(Int intVisMode);
Function groupVisUtil();
Function layerVisMouseTrapLeftClick();
Function layerVisMouseTrapRightClick();

Global Timer timerVisRefresh;

Global Layer layerMainNormalVisMouseTrap;
Global Group groupMainNormalVisualizers;
Global Group groupMainNormalVis1;
Global Group groupMainNormalVis2;
Global Group groupMainNormalVis3;
Global Group groupMainNormalVis4;
Global Group groupMainNormalVis5;
Global Group groupMainNormalVis6;
Global Group groupMainNormalVis7;
Global Group groupMainNormalVis8;
Global Group groupMainNormalVis9;
Global Group groupMainNormalVis10;
Global Group groupMainNormalVis11;
Global Group groupMainNormalVis12;
Global Group groupMainNormalVis13;
Global AnimatedLayer layerMainNormalVis5;
Global AnimatedLayer layerMainNormalVis6;
Global AnimatedLayer layerMainNormalVis7;
Global AnimatedLayer layerMainNormalVis8;
Global AnimatedLayer layerMainNormalVis9;
Global AnimatedLayer layerMainNormalVis10;
Global AnimatedLayer layerMainNormalVis11;
Global AnimatedLayer layerMainNormalVis12;
Global AnimatedLayer layerMainNormalVis13;

Global Layer layerMainCompactVisMouseTrap;
Global Group groupMainCompactVisualizers;
Global Group groupMainCompactVis1;
Global Group groupMainCompactVis2;
Global Group groupMainCompactVis3;
Global Group groupMainCompactVis4;
Global Group groupMainCompactVis5;
Global Group groupMainCompactVis6;
Global Group groupMainCompactVis7;
Global Group groupMainCompactVis8;
Global Group groupMainCompactVis9;
Global Group groupMainCompactVis10;
Global Group groupMainCompactVis11;
Global Group groupMainCompactVis12;
Global Group groupMainCompactVis13;
Global AnimatedLayer layerMainCompactVis5;
Global AnimatedLayer layerMainCompactVis6;
Global AnimatedLayer layerMainCompactVis7;
Global AnimatedLayer layerMainCompactVis8;
Global AnimatedLayer layerMainCompactVis9;
Global AnimatedLayer layerMainCompactVis10;
Global AnimatedLayer layerMainCompactVis11;
Global AnimatedLayer layerMainCompactVis12;
Global AnimatedLayer layerMainCompactVis13;

Global Int intValueLeftPrevious;
Global Int intValueRightPrevious;
Global Int intValueShortAveragePrevious;
Global Int intValueShort2AveragePrevious;
Global Int intValueLongAveragePrevious;

Global Int intMainVisLongFrameCount;
Global Int intMainVisShortFrameCount;
Global Int intMainVisShort2FrameCount;
Global Int intMainVisMode;
Global Int intMainVisFramerateMod;

initVisualizers() {
	groupMainNormalVisualizers = layoutMainNormal.findObject("player.normal.group.drawer.visualizers");
	layerMainNormalVisMouseTrap = layoutMainNormal.findObject("player.normal.visualizer.mousetrap");
	groupMainNormalVis1 = layoutMainNormal.findObject("player.visualizer.1");
	groupMainNormalVis2 = layoutMainNormal.findObject("player.visualizer.2");
	groupMainNormalVis3 = layoutMainNormal.findObject("player.visualizer.3");
	groupMainNormalVis4 = layoutMainNormal.findObject("player.visualizer.4");
	groupMainNormalVis5 = layoutMainNormal.findObject("player.visualizer.5");
	groupMainNormalVis6 = layoutMainNormal.findObject("player.visualizer.6");
	groupMainNormalVis7 = layoutMainNormal.findObject("player.visualizer.7");
	groupMainNormalVis8 = layoutMainNormal.findObject("player.visualizer.8");
	groupMainNormalVis9 = layoutMainNormal.findObject("player.visualizer.9");
	groupMainNormalVis10 = layoutMainNormal.findObject("player.visualizer.10");
	groupMainNormalVis11 = layoutMainNormal.findObject("player.visualizer.11");
	groupMainNormalVis12 = layoutMainNormal.findObject("player.visualizer.12");
	groupMainNormalVis13 = layoutMainNormal.findObject("player.visualizer.13");
	layerMainNormalVis5 = groupMainNormalVis5.findObject("player.visualizer.animation.5");
	layerMainNormalVis6 = groupMainNormalVis6.findObject("player.visualizer.animation.6");
	layerMainNormalVis7 = groupMainNormalVis7.findObject("player.visualizer.animation.7");
	layerMainNormalVis8 = groupMainNormalVis8.findObject("player.visualizer.animation.8");
	layerMainNormalVis9 = groupMainNormalVis9.findObject("player.visualizer.animation.9");
	layerMainNormalVis10 = groupMainNormalVis10.findObject("player.visualizer.animation.10");
	layerMainNormalVis11 = groupMainNormalVis11.findObject("player.visualizer.animation.11");
	layerMainNormalVis12 = groupMainNormalVis12.findObject("player.visualizer.animation.12");
	layerMainNormalVis13 = groupMainNormalVis12.findObject("player.visualizer.animation.13");
	
	groupMainCompactVisualizers = layoutMainCompact.findObject("player.compact.group.visualizers");
	layerMainCompactVisMouseTrap = layoutMainCompact.findObject("player.compact.visualizer.mousetrap");
	groupMainCompactVis1 = layoutMainCompact.findObject("player.visualizer.1");
	groupMainCompactVis2 = layoutMainCompact.findObject("player.visualizer.2");
	groupMainCompactVis3 = layoutMainCompact.findObject("player.visualizer.3");
	groupMainCompactVis4 = layoutMainCompact.findObject("player.visualizer.4");
	groupMainCompactVis5 = layoutMainCompact.findObject("player.visualizer.5");
	groupMainCompactVis6 = layoutMainCompact.findObject("player.visualizer.6");
	groupMainCompactVis7 = layoutMainCompact.findObject("player.visualizer.7");
	groupMainCompactVis8 = layoutMainCompact.findObject("player.visualizer.8");
	groupMainCompactVis9 = layoutMainCompact.findObject("player.visualizer.9");
	groupMainCompactVis10 = layoutMainCompact.findObject("player.visualizer.10");
	groupMainCompactVis11 = layoutMainCompact.findObject("player.visualizer.11");
	groupMainCompactVis12 = layoutMainCompact.findObject("player.visualizer.12");
	groupMainCompactVis13 = layoutMainCompact.findObject("player.visualizer.13");
	layerMainCompactVis5 = groupMainCompactVis5.findObject("player.visualizer.animation.5");
	layerMainCompactVis6 = groupMainCompactVis6.findObject("player.visualizer.animation.6");
	layerMainCompactVis7 = groupMainCompactVis7.findObject("player.visualizer.animation.7");
	layerMainCompactVis8 = groupMainCompactVis8.findObject("player.visualizer.animation.8");
	layerMainCompactVis9 = groupMainCompactVis9.findObject("player.visualizer.animation.9");
	layerMainCompactVis10 = groupMainCompactVis10.findObject("player.visualizer.animation.10");
	layerMainCompactVis11 = groupMainCompactVis11.findObject("player.visualizer.animation.11");
	layerMainCompactVis12 = groupMainCompactVis11.findObject("player.visualizer.animation.12");
	layerMainCompactVis13 = groupMainCompactVis12.findObject("player.visualizer.animation.13");
	
	intMainVisFramerateMod = 0;
	intMainVisLongFrameCount = layerMainNormalVis11.getLength();
	intMainVisShortFrameCount = layerMainNormalVis5.getLength();
	intMainVisShort2FrameCount = layerMainNormalVis10.getLength();

	intMainVisMode = System.getPrivateInt(System.getSkinName(), "intMainVisMode", 1);
	
	setMainVisualizer(intMainVisMode);
	
	timerVisRefresh = new Timer;
	timerVisRefresh.setDelay(10);
	timerVisRefresh.start();
}

unloadVisualizers() {
	timerVisRefresh.stop();
	delete timerVisRefresh;
}

groupMainNormalVisualizers.onSetVisible(Boolean boolIsVisible) { groupVisUtil(); }
groupMainCompactVisualizers.onSetVisible(Boolean boolIsVisible) { groupVisUtil(); }

groupVisUtil() {
	if (groupMainNormalVisualizers.isVisible() || groupMainCompactVisualizers.isVisible()) {
		timerVisRefresh.start();
	} else {
		timerVisRefresh.stop();
	}
}

timerVisRefresh.onTimer() {
	refreshVisualizers();
}

layerMainNormalVisMouseTrap.onLeftButtonDown(Int intPosX, Int intPosY) { layerVisMouseTrapLeftClick(); }
layerMainCompactVisMouseTrap.onLeftButtonDown(Int intPosX, Int intPosY) { layerVisMouseTrapLeftClick(); }

layerVisMouseTrapLeftClick() {
	setMainVisualizer(intMainVisMode + 1);
}

layerMainNormalVisMouseTrap.onRightbuttonUp(Int intPosX, Int intPosY) { layerVisMouseTrapRightClick(); }
layerMainCompactVisMouseTrap.onRightbuttonUp(Int intPosX, Int intPosY) { layerVisMouseTrapRightClick(); }

layerVisMouseTrapRightClick() {
	PopupMenu popupVisualizations;
	Int intSelection;
	
	popupVisualizations = new PopupMenu;
	popupVisualizations.addCommand("Off", 0, (intMainVisMode == 0), 0);
	popupVisualizations.addSeparator();
	popupVisualizations.addCommand("Spectrum Analyzer", 1, (intMainVisMode == 1), 0);
	popupVisualizations.addCommand("Mirrored Double Spectrum Analyzer", 2, (intMainVisMode == 2), 0);
	popupVisualizations.addCommand("Oscilliscope", 3, (intMainVisMode == 3), 0);
	popupVisualizations.addCommand("Mirrored Double Spectrum Oscilliscope", 4, (intMainVisMode == 4), 0);
	if (configAttribute_eeState.getData() == "1") {
		popupVisualizations.addSeparator();
		popupVisualizations.addCommand("Seagoat Jump", 5, (intMainVisMode == 5), 0);
		popupVisualizations.addCommand("Gordon Freeman and Lamarr", 6, (intMainVisMode == 6), 0);
		popupVisualizations.addCommand("Stormtrooper and Luke", 7, (intMainVisMode == 7), 0);
		popupVisualizations.addCommand("Neo and Agent Smith", 8, (intMainVisMode == 8), 0);
		popupVisualizations.addCommand("Spongebob Run", 9, (intMainVisMode == 9), 0);
		popupVisualizations.addCommand("Trite Bounce", 10, (intMainVisMode == 10), 0);
	}
	popupVisualizations.addSeparator();
	popupVisualizations.addCommand("Core Display", 11, (intMainVisMode == 11), 0);
	popupVisualizations.addCommand("Breed Pulse Scope", 12, (intMainVisMode == 12), 0);
	popupVisualizations.addCommand("Operator Hack Screen", 13, (intMainVisMode == 13), 0);
	
	System.setPrivateInt(System.getSkinName(), "Popup Visible", 1);
	intSelection = popupVisualizations.popAtMouse();
	System.setPrivateInt(System.getSkinName(), "Popup Visible", 0);
	
	if (intSelection > -1) {
		setMainVisualizer(intSelection);
	}
	
	delete popupVisualizations;
	complete;
}

setMainVisualizer(Int intVisMode) {
	Vis visTemp;
	Boolean boolEEEnabled = (configAttribute_eeState.getData() == "1");
	
	groupMainNormalVis1.hide();
	groupMainNormalVis2.hide();
	groupMainNormalVis3.hide();
	groupMainNormalVis4.hide();
	groupMainNormalVis5.hide();
	groupMainNormalVis6.hide();
	groupMainNormalVis7.hide();
	groupMainNormalVis8.hide();
	groupMainNormalVis9.hide();
	groupMainNormalVis10.hide();
	groupMainNormalVis11.hide();
	groupMainNormalVis12.hide();
	groupMainNormalVis13.hide();
	
	groupMainCompactVis1.hide();
	groupMainCompactVis2.hide();
	groupMainCompactVis3.hide();
	groupMainCompactVis4.hide();
	groupMainCompactVis5.hide();
	groupMainCompactVis6.hide();
	groupMainCompactVis7.hide();
	groupMainCompactVis8.hide();
	groupMainCompactVis9.hide();
	groupMainCompactVis10.hide();
	groupMainCompactVis11.hide();
	groupMainCompactVis12.hide();
	groupMainCompactVis13.hide();
	
	visTemp = groupMainNormalVis1.findObject("player.vis.1"); visTemp.setMode(1);
	visTemp = groupMainNormalVis2.findObject("player.vis.2a"); visTemp.setMode(1);
	visTemp = groupMainNormalVis2.findObject("player.vis.2b"); visTemp.setMode(1);
	visTemp = groupMainNormalVis3.findObject("player.vis.3"); visTemp.setMode(2);
	visTemp = groupMainNormalVis4.findObject("player.vis.4a"); visTemp.setMode(2);
	visTemp = groupMainNormalVis4.findObject("player.vis.4b"); visTemp.setMode(2);
	
	visTemp = groupMainCompactVis1.findObject("player.vis.1"); visTemp.setMode(1);
	visTemp = groupMainCompactVis2.findObject("player.vis.2a"); visTemp.setMode(1);
	visTemp = groupMainCompactVis2.findObject("player.vis.2b"); visTemp.setMode(1);
	visTemp = groupMainCompactVis3.findObject("player.vis.3"); visTemp.setMode(2);
	visTemp = groupMainCompactVis4.findObject("player.vis.4a"); visTemp.setMode(2);
	visTemp = groupMainCompactVis4.findObject("player.vis.4b"); visTemp.setMode(2);
	
	// Skip ahead to non-hidden visualizers
	if (intVisMode > 4 && intVisMode < 11 && !boolEEEnabled) intVisMode = 11;
	
	if (intVisMode == 1) {
		groupMainNormalVis1.show();
		groupMainCompactVis1.show();
	} else if (intVisMode == 2) {
		groupMainNormalVis2.show();
		groupMainCompactVis2.show();
	} else if (intVisMode == 3) {
		groupMainNormalVis3.show();
		groupMainCompactVis3.show();
	} else if (intVisMode == 4) {
		groupMainNormalVis4.show();
		groupMainCompactVis4.show();
	} else if (intVisMode == 5 && boolEEEnabled) {
		groupMainNormalVis5.show();
		groupMainCompactVis5.show();
	} else if (intVisMode == 6 && boolEEEnabled) {
		groupMainNormalVis6.show();
		groupMainCompactVis6.show();
	} else if (intVisMode == 7 && boolEEEnabled) {
		groupMainNormalVis7.show();
		groupMainCompactVis7.show();
	} else if (intVisMode == 8 && boolEEEnabled) {
		groupMainNormalVis8.show();
		groupMainCompactVis8.show();
	} else if (intVisMode == 9 && boolEEEnabled) {
		groupMainNormalVis9.show();
		groupMainCompactVis9.show();
	} else if (intVisMode == 10 && boolEEEnabled) {
		groupMainNormalVis10.show();
		groupMainCompactVis10.show();
	} else if (intVisMode == 11) {
		groupMainNormalVis11.show();
		groupMainCompactVis11.show();
	} else if (intVisMode == 12) {
		groupMainNormalVis12.show();
		groupMainCompactVis12.show();
	} else if (intVisMode == 13) {
		groupMainNormalVis13.show();
		groupMainCompactVis13.show();
	} else {
		intVisMode = 0;
	}
	
	intMainVisMode = intVisMode;
	System.setPrivateInt(System.getSkinName(), "intMainVisMode", intMainVisMode);
}

refreshVisualizers() {
	Int intValueLeft;
	Int intValueRight;
	Int intValueAverage;
	Int intValueShortAverage;
	Int intValueShort2Average;
	Int intValueLongAverage;
	Int intValueAverageOverTime;
		
	if (intMainVisMode > 4) {
		intValueAverage = (System.getLeftVuMeter() + System.getRightVuMeter()) / 2;
	} else {
		intValueAverage = 0;
	}
	
	intValueAverageOverTime = getVisualizerAverageOverTime(intValueAverage);
	
	intMainVisFramerateMod++;
	if (intMainVisFramerateMod > 10) intMainVisFramerateMod = 0;
	if (intMainVisFramerateMod % 10 == 0) {
		Int intMainNormalVisFrameRate = 61 - ((intValueAverageOverTime * 60) / 255);
	
		layerMainNormalVis7.setSpeed((intMainNormalVisFrameRate / 3) + 1);
		layerMainCompactVis7.setSpeed((intMainNormalVisFrameRate / 3) + 1);
		layerMainNormalVis8.setSpeed(intMainNormalVisFrameRate);
		layerMainCompactVis8.setSpeed(intMainNormalVisFrameRate);
		layerMainNormalVis9.setSpeed(intMainNormalVisFrameRate);
		layerMainCompactVis9.setSpeed(intMainNormalVisFrameRate);
		
		layerMainNormalVis13.setSpeed(intMainNormalVisFrameRate * 2);
		layerMainCompactVis13.setSpeed(intMainNormalVisFrameRate * 2);
	}
	
	intValueShortAverage = intValueAverage;
	if (intValueShortAverage < intValueShortAveragePrevious) intValueShortAverage = intValueShortAveragePrevious - (255 / (intMainVisShortFrameCount - 1));
	if (intValueShortAverage < 0) intValueShortAverage = 0;
	Int intMainNormalShortVisFrame = (intValueShortAverage * intMainVisShortFrameCount - 1) / 255;
	
	intValueShort2Average = intValueAverage;
	if (intValueShort2Average < intValueShort2AveragePrevious) intValueShort2Average = intValueShort2AveragePrevious - 1;
	if (intValueShort2Average < 0) intValueShort2Average = 0;
	Int intMainNormalShort2VisFrame = (intValueShort2Average * intMainVisShort2FrameCount - 1) / 255;
	
	intValueLongAverage = intValueAverage;
	if (intValueLongAverage < intValueLongAveragePrevious) intValueLongAverage = intValueLongAveragePrevious - (255 / ((intMainVisLongFrameCount / 2) - 1));
	if (intValueLongAverage < 0) intValueLongAverage = 0;
	Int intMainNormalLongVisFrame = (intValueLongAverage * intMainVisLongFrameCount - 1) / 255;
	
	layerMainNormalVis5.gotoFrame(intMainNormalShortVisFrame);
	layerMainNormalVis6.gotoFrame(intMainNormalShortVisFrame);
	layerMainCompactVis5.gotoFrame(intMainNormalShortVisFrame);
	layerMainCompactVis6.gotoFrame(intMainNormalShortVisFrame);
	
	layerMainNormalVis10.gotoFrame(intMainNormalShort2VisFrame);
	layerMainCompactVis10.gotoFrame(intMainNormalShort2VisFrame);
	
	layerMainNormalVis11.gotoFrame(intMainNormalLongVisFrame);
	layerMainNormalVis12.gotoFrame(intMainNormalLongVisFrame);
	layerMainCompactVis11.gotoFrame(intMainNormalLongVisFrame);
	layerMainCompactVis12.gotoFrame(intMainNormalLongVisFrame);
	
	intValueLeftPrevious = intValueLeft;
	intValueRightPrevious = intValueRight;
	intValueShortAveragePrevious = intValueShortAverage;
	intValueLongAveragePrevious = intValueLongAverage;
}

Global Int intVisSampleIndex = 0;
Global Int intVisSample00 = 0;
Global Int intVisSample01 = 0;
Global Int intVisSample02 = 0;
Global Int intVisSample03 = 0;
Global Int intVisSample04 = 0;
Global Int intVisSample05 = 0;
Global Int intVisSample06 = 0;
Global Int intVisSample07 = 0;
Global Int intVisSample08 = 0;
Global Int intVisSample09 = 0;
Global Int intVisSample10 = 0;
Global Int intVisSample11 = 0;
Global Int intVisSample12 = 0;
Global Int intVisSample13 = 0;
Global Int intVisSample14 = 0;
Global Int intVisSample15 = 0;
Global Int intVisSample16 = 0;
Global Int intVisSample17 = 0;
Global Int intVisSample18 = 0;
Global Int intVisSample19 = 0;


Int getVisualizerAverageOverTime(Int intCurrentAverage) {
	Int intReturnValue = 0;
	
	if (intVisSampleIndex == 0) intVisSample00 = intCurrentAverage;
	if (intVisSampleIndex == 1) intVisSample01 = intCurrentAverage;
	if (intVisSampleIndex == 2) intVisSample02 = intCurrentAverage;
	if (intVisSampleIndex == 3) intVisSample03 = intCurrentAverage;
	if (intVisSampleIndex == 4) intVisSample04 = intCurrentAverage;
	if (intVisSampleIndex == 5) intVisSample05 = intCurrentAverage;
	if (intVisSampleIndex == 6) intVisSample06 = intCurrentAverage;
	if (intVisSampleIndex == 7) intVisSample07 = intCurrentAverage;
	if (intVisSampleIndex == 8) intVisSample08 = intCurrentAverage;
	if (intVisSampleIndex == 9) intVisSample09 = intCurrentAverage;
	if (intVisSampleIndex == 10) intVisSample10 = intCurrentAverage;
	if (intVisSampleIndex == 11) intVisSample11 = intCurrentAverage;
	if (intVisSampleIndex == 12) intVisSample12 = intCurrentAverage;
	if (intVisSampleIndex == 13) intVisSample13 = intCurrentAverage;
	if (intVisSampleIndex == 14) intVisSample14 = intCurrentAverage;
	if (intVisSampleIndex == 15) intVisSample15 = intCurrentAverage;
	if (intVisSampleIndex == 16) intVisSample16 = intCurrentAverage;
	if (intVisSampleIndex == 17) intVisSample17 = intCurrentAverage;
	if (intVisSampleIndex == 18) intVisSample18 = intCurrentAverage;
	if (intVisSampleIndex == 19) intVisSample19 = intCurrentAverage;
	
	intReturnValue = (intVisSample00 + intVisSample01 + intVisSample02 + intVisSample03 + intVisSample04 + intVisSample05 + intVisSample06 + intVisSample07 + intVisSample08 + intVisSample09 + intVisSample10 + intVisSample11 + intVisSample12 + intVisSample13 + intVisSample14 + intVisSample15 + intVisSample16 + intVisSample17 + intVisSample18 + intVisSample19) / 20;
	
	intVisSampleIndex++;
	if (intVisSampleIndex > 19) intVisSampleIndex = 0;
	
	return intReturnValue;
}